/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package batchable;

import MorphAnalyser.MorphAnalyser;
import MorphAnalyser.MorphAnalyser2;
import MorphAnalyser.ObjectGeometry;
import MorphAnalyser.Template3D;
import MorphAnalyser.batch.Batchable3D;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import javax.vecmath.Point3f;

/**
 *
 * @author bpt
 */
public class BatchGetSizeShift implements Batchable3D {
    PrintWriter pw=null;
    MorphAnalyser2 morphanalyser=null;

    public boolean process(ObjectGeometry obj, Template3D t3d, boolean single) {
        
        Point3f centre = obj.getCentre();
        double R = obj.getMeanRadiusSquared(centre);
        if (single) {
            JOptionPane.showMessageDialog(morphanalyser, R + ", " + centre.x + ", " + centre.y + ", " + centre.z, "Results", JOptionPane.INFORMATION_MESSAGE);
            return true;
        }
        pw.println(R + ", " + centre.x + ", " + centre.y + ", " + centre.z);
        return true;
    }

    public boolean initialise(MorphAnalyser2 morphanalyser) {
        this.morphanalyser = morphanalyser;

            JFileChooser chooser = morphanalyser.getFileChooser();
            chooser.setFileFilter(new FileFilter() {

                @Override
                public boolean accept(File file) {
                    String path = file.getName();
                    if (path.endsWith(".txt")) {
                        return true;
                    }
                    if (path.endsWith(".csv")) {
                        return true;
                    }
                    return false;

                }

                @Override
                public String getDescription() {
                    return "Text / CSV Files";
                }
            });
            int res = chooser.showSaveDialog(morphanalyser);
            if (res == JFileChooser.CANCEL_OPTION) {
                return false;
            }

            File f = chooser.getSelectedFile();
            try {
                FileWriter fw = new FileWriter(f);
                pw = new PrintWriter(fw);
            } catch (IOException ex) {
                Logger.getLogger(BatchGetSizeShift.class.getName()).log(Level.SEVERE, null, ex);
                return false;
            }

        return true;
    }

    public void finish() {
        if (pw!=null) {
            pw.flush();
            pw.close();
        }
    }

    public String getName() {
        return "Measure size and shift";
    }

    public boolean getReadTemplate3D() {
        return false;
    }

    public boolean getWriteTemplate3D() {
        return false;
    }

    public boolean getWriteObjectGeometry() {
        return false;
    }


}
