#pragma optionNV(unroll all)

varying vec3 normal;
varying vec2 texCoord;
varying vec3 ecPosition;
varying vec4 ecPosition4;

uniform int enabledLights[8];
varying vec3 lightsVec[8];
varying vec4 position;


void main(void)
{
    vec4 vert = gl_Vertex;
    ecPosition4 = gl_ModelViewMatrix * vert;
    ecPosition = (vec3(ecPosition4)) / ecPosition4.w ;

    for(int i = 0 ; i < 8 ; i++){
        if( enabledLights[i] == 1){
            vec3 LightPosition =  gl_LightSource[i].position.xyz;
            lightsVec[i]   = normalize(LightPosition - ecPosition);
        }
    }

    normal = normalize(gl_NormalMatrix * gl_Normal);
 
    gl_Position = gl_ModelViewProjectionMatrix * vert;
    position = gl_ModelViewProjectionMatrix * vert;
    texCoord = gl_MultiTexCoord0.st;
}
