uniform sampler2D subTexture;
uniform sampler2D bumpTexture;

varying vec2 texCoord;
varying vec3 lightVec;
varying vec3 ecPosition;
//varying vec3 norm;

void main(void)
{
    vec3 normalShift = texture2D(bumpTexture, texCoord.st).rgb;
    normalShift-=0.5;
    normalShift*=2.0;

    normalShift = normalize(gl_NormalMatrix * normalShift);

    vec3 reflectVec = reflect(-lightVec, normalShift);
    reflectVec = normalize(reflectVec);
    vec3 viewVec    = normalize(-ecPosition);
    float diffuse   = max(dot(lightVec, normalShift), 0.0);
    float spec      = 0.0;

    if (diffuse > 0.0)
    {
        spec = max(dot(reflectVec, viewVec), 0.0);
        spec = pow(spec, gl_FrontMaterial.shininess);
    }

  vec3 LightIntensity = (gl_FrontMaterial.specular.rgb*gl_LightSource[0].specular.rgb*spec) + gl_FrontMaterial.diffuse.rgb*gl_LightSource[0].diffuse.rgb*diffuse+ gl_FrontMaterial.ambient.rgb*gl_LightSource[0].ambient.rgb + gl_FrontMaterial.emission.rgb;// +  + gl_LightSource[0].ambient.rgb;
    vec3  texColor;
    texColor =  texture2D(subTexture, texCoord.st).rgb; // * 0.5 + texture2D(bumpTexture, texCoord.st).rgb*0.5; 
    texColor *= LightIntensity;
  // texColor = vec3(1.0,0.0,0.0);
    gl_FragColor = vec4 (texColor, 1.0);
}
